/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /work/mozilla/mozilla/content/html/document/public/nsIWyciwygChannel.idl
 */

#ifndef __gen_nsIWyciwygChannel_h__
#define __gen_nsIWyciwygChannel_h__


#ifndef __gen_nsIChannel_h__
#include "nsIChannel.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIWyciwygChannel */
#define NS_IWYCIWYGCHANNEL_IID_STR "c36730c0-a3b9-4732-9973-c5e7dbe0dabe"

#define NS_IWYCIWYGCHANNEL_IID \
  {0xc36730c0, 0xa3b9, 0x4732, \
    { 0x99, 0x73, 0xc5, 0xe7, 0xdb, 0xe0, 0xda, 0xbe }}

/**
 * A channel to  manage all cache-related interactions for layout
 * when it is dealing with dynamic pages created through 
 * document.write(). This interface provides methods that will
 * help layout save dynamic pages in cache for future retrievals.
 */
class NS_NO_VTABLE nsIWyciwygChannel : public nsIChannel {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IWYCIWYGCHANNEL_IID)

  /* void createCacheEntry (in string cacheKey); */
  NS_IMETHOD CreateCacheEntry(const char *cacheKey) = 0;

  /* void writeToCache (in string aScript); */
  NS_IMETHOD WriteToCache(const char *aScript) = 0;

  /* void closeCacheEntry (); */
  NS_IMETHOD CloseCacheEntry(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIWYCIWYGCHANNEL \
  NS_IMETHOD CreateCacheEntry(const char *cacheKey); \
  NS_IMETHOD WriteToCache(const char *aScript); \
  NS_IMETHOD CloseCacheEntry(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIWYCIWYGCHANNEL(_to) \
  NS_IMETHOD CreateCacheEntry(const char *cacheKey) { return _to CreateCacheEntry(cacheKey); } \
  NS_IMETHOD WriteToCache(const char *aScript) { return _to WriteToCache(aScript); } \
  NS_IMETHOD CloseCacheEntry(void) { return _to CloseCacheEntry(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIWYCIWYGCHANNEL(_to) \
  NS_IMETHOD CreateCacheEntry(const char *cacheKey) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateCacheEntry(cacheKey); } \
  NS_IMETHOD WriteToCache(const char *aScript) { return !_to ? NS_ERROR_NULL_POINTER : _to->WriteToCache(aScript); } \
  NS_IMETHOD CloseCacheEntry(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->CloseCacheEntry(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsWyciwygChannel : public nsIWyciwygChannel
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIWYCIWYGCHANNEL

  nsWyciwygChannel();
  virtual ~nsWyciwygChannel();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsWyciwygChannel, nsIWyciwygChannel)

nsWyciwygChannel::nsWyciwygChannel()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsWyciwygChannel::~nsWyciwygChannel()
{
  /* destructor code */
}

/* void createCacheEntry (in string cacheKey); */
NS_IMETHODIMP nsWyciwygChannel::CreateCacheEntry(const char *cacheKey)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void writeToCache (in string aScript); */
NS_IMETHODIMP nsWyciwygChannel::WriteToCache(const char *aScript)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void closeCacheEntry (); */
NS_IMETHODIMP nsWyciwygChannel::CloseCacheEntry()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIWyciwygChannel_h__ */
