#ifndef GCFG_INC
#define GCFG_INC

/* =====================================================
 *      SO_ROOT definition
 * =====================================================*/

#ifdef SRV_PRODUCT
#define GID_MODULE_SO_ROOT GID_MODULE_OFFICE_SERVER
#elif defined WEB_PRODUCT
#define GID_MODULE_SO_ROOT GID_MODULE_FAT_OFFICE
#else
#define GID_MODULE_SO_ROOT GID_MODULE_ROOT
#endif

/* =====================================================
 *       Styles = (DONT_SELECT_BY_USER);    definition
 * =====================================================*/

#if defined( SRV_PRODUCT ) || defined( WEB_PRODUCT )
#define NO_DONT_SELECT_PRODUCT
#endif

/* =====================================================
 *       Webtop mini is also a Webtop
 * =====================================================*/

#if defined( WEM_PRODUCT )
#define WEB_PRODUCT
#endif

/* =====================================================
 *       Making Classic Fat-Product available
 * =====================================================*/

#if defined( FAT_PRODUCT ) || defined( OFS_PRODUCT ) || defined (C01_PRODUCT) || defined( C02_PRODUCT )
#define CLASSIC_FAT_PRODUCT
#endif


/* =====================================================
 *		StarOffice FAT
 * =====================================================*/

#if defined( FAM_PRODUCT ) || defined( OSL_PRODUCT ) || defined( WEB_PRODUCT ) || defined( OFS_PRODUCT ) || defined( OMC_PRODUCT ) || defined( PP1_PRODUCT ) || defined (C01_PRODUCT) || defined( C02_PRODUCT )
#define FAT_PRODUCT
#endif

#ifdef FAT_PRODUCT

#ifdef UNX
    #ifdef WEB_PRODUCT
        #define         GCFG_DEF_DESTPATH                   "webtop"
    #elif defined FAM_PRODUCT
        #define         GCFG_DEF_DESTPATH                   "${UNIXPATH}%PRODUCTVERSION"
    #elif defined CLASSIC_FAT_PRODUCT
        #define         GCFG_DEF_DESTPATH                   "${UNIXPATH}%PRODUCTVERSION"
    #else
        #define         GCFG_DEF_DESTPATH                   "%PRODUCTNAME%PRODUCTVERSION"
    #endif
#else
    #ifdef WEB_PRODUCT
        #define         GCFG_DEF_DESTPATH                   "<winprogpath>\webtop"
    #else
        #define         GCFG_DEF_DESTPATH                   "<winprogpath>\%PRODUCTNAME%PRODUCTVERSION"
    #endif
#endif

#define         GCFG_DATACARRIER                    "%PRODUCTNAME %PRODUCTVERSION"

#ifdef OSL_PRODUCT
    #define         GCFG_TIME_STAMP                     "0110"
    #define         GCFG_DATE_STAMP                     STRING(SCP_DATESTRING)
#else
    #define         GCFG_TIME_STAMP                     "0704"
    #define         GCFG_DATE_STAMP                     "01102004"  // Format ddmmyyyy
#endif

#define         GCFG_BINARY_DIR                     GID_DIR_PROGRAM
#define         GCFG_RESOURCE_DIR                   GID_DIR_RESOURCE
#define         GCFG_CLASSES_DIR                    GID_DIR_CLASSES

/* =====================================================
 *		StarOffice Server
 * =====================================================*/
#elif SRV_PRODUCT

#ifdef UNX
#define         GCFG_DEF_DESTPATH                   "sun_webtop"
#else
#define         GCFG_DEF_DESTPATH                   "<winprogpath>\sun_webtop"
#endif

#define         GCFG_DATACARRIER                    "sun_webtop_1_1"
#define         GCFG_TODAY_DATE_STAMP               STRING(SCP_DATESTRING)
#define         GCFG_DATE_STAMP                     "30082002"  // Format ddmmyyyy
#define         GCFG_TIME_STAMP                     "0110"
#define         GCFG_BINARY_DIR                     GID_DIR_PROGRAM
#define         GCFG_RESOURCE_DIR                   GID_DIR_RESOURCE
#define         GCFG_CLASSES_DIR                    GID_DIR_CLASSES

/* =====================================================
 *		Adabas Setup
 * =====================================================*/
#elif ADA_PRODUCT

#ifdef UNX
#define         GCFG_DEF_DESTPATH                   "adabas"
#else
#define         GCFG_DEF_DESTPATH                   "<winprogpath>\Adabas"
#endif

#define         GCFG_ADABAS_FOLDER                  "Adabas"
#define         GCFG_ADABAS_FOLDERENTRY             "Adabas"
#define         GCFG_ADABAS_SETUP                   "Adabas Setup"
#define         GCFG_ADABAS_VERSIONKEY              "Adabas D 12.0.1"

#define         GCFG_DATACARRIER                    "Adabas"
#define         GCFG_DATE_STAMP                     "01022004"  // Format ddmmyyyy
#define         GCFG_TIME_STAMP                     "0700"

#define         GCFG_BINARY_DIR                     GID_DIR_DATABASE_ADABAS_ADABAS
#define         GCFG_RESOURCE_DIR                   GID_DIR_DATABASE_ADABAS_ADABAS
#define         GCFG_CLASSES_DIR                    GID_DIR_DATABASE_ADABAS_ADABAS_CLASSES
/* =====================================================
 *		Adabas Multikulti Setup
 * =====================================================*/
#elif ADM_PRODUCT

#ifdef UNX
#define         GCFG_DEF_DESTPATH                   "adabas"
#else
#define         GCFG_DEF_DESTPATH                   "<winprogpath>\Adabas"
#endif

#define         GCFG_ADABAS_FOLDER                  "Adabas"
#define         GCFG_ADABAS_FOLDERENTRY             "Adabas"
#define         GCFG_ADABAS_SETUP                   "Adabas Setup"
#define         GCFG_ADABAS_VERSIONKEY              "Adabas D 12.0.1"

#define         GCFG_DATACARRIER                    "Adabas"
#define         GCFG_DATE_STAMP                     "01022004"  // Format ddmmyyyy
#define         GCFG_TIME_STAMP                     "0700"

#define         GCFG_BINARY_DIR                     GID_DIR_DATABASE_ADABAS_ADABAS
#define         GCFG_RESOURCE_DIR                   GID_DIR_DATABASE_ADABAS_ADABAS
#define         GCFG_CLASSES_DIR                    GID_DIR_DATABASE_ADABAS_ADABAS_CLASSES
#endif

/* =====================================================
 * global helper macros
 * =====================================================*/

#define DOSTRING( x )						#x
#define STRING( x )							DOSTRING( x )

#define DOCONCAT2( x, y )					x##y
#define CONCAT2( x, y)						DOCONCAT2(x,y)
#define DOCONCAT3( x, y, z )				x##y##z
#define CONCAT3( x, y, z )					DOCONCAT3(x,y,z)
#define DOCONCAT4( x, y, z, a )				x##y##z##a
#define CONCAT4( x, y, z, a )				DOCONCAT4(x,y,z,a)
#define DOCONCAT5( x, y, z, a, b )			x##y##z##a##b
#define CONCAT5( x, y, z, a, b )	 		DOCONCAT5(x,y,z,a,b)
#define DOCONCAT6( x, y, z, a, b, c )		x##y##z##a##b##c
#define CONCAT6( x, y, z, a, b, c )			DOCONCAT6(x,y,z,a,b,c)
#define DOCONCAT7( x, y, z, a, b, c, u)     x##y##z##a##b##c##u
#define CONCAT7( x, y, z, a, b, c, u)       DOCONCAT7(x,y,z,a,b,c,u)
#define DOCONCAT8( x, y, z, a, b, c, u, v)  x##y##z##a##b##c##u##v
#define CONCAT8( x, y, z, a, b, c, u, v)    DOCONCAT8(x,y,z,a,b,c,u,v)
#define DOCONCAT9( x, y, z, a, b, c, u, v, w)  x##y##z##a##b##c##u##v##w
#define CONCAT9( x, y, z, a, b, c, u, v, w)    DOCONCAT9(x,y,z,a,b,c,u,v,w)

/* --------------------------------------------------*/

#define FILE_BODY \
	Carrier			= GID_DATACARRIER;	\
	Date			= GCFG_DATE_STAMP;	\
	Time			= GCFG_TIME_STAMP;

#define BIN_FILE_BODY FILE_BODY \
	UnixRights		= 555

#define TXT_FILE_BODY FILE_BODY \
	UnixRights		= 444

#define USER_FILE_BODY FILE_BODY \
	UnixRights		= 644

#define TODAY_FILE_BODY \
	Carrier			= GID_DATACARRIER;	\
    Date            = GCFG_TODAY_DATE_STAMP;  \
	Time			= GCFG_TIME_STAMP;

#define TODAY_BIN_FILE_BODY TODAY_FILE_BODY \
	UnixRights		= 555

#define TODAY_TXT_FILE_BODY TODAY_FILE_BODY \
	UnixRights		= 444

/* --------------------------------------------------*/

#ifdef UNX
#ifdef MACOSX
#define UNXSUFFIX .dylib
#else
#define UNXSUFFIX .so
#endif
#endif

#ifdef UNX
#define LIBNAME(name)                       STRING(CONCAT5(lib,name,OFFICEUPD,DLLSUFFIX,UNXSUFFIX))
#define LIBSHORTNAME(name)                  STRING(CONCAT4(lib,name,DLLSUFFIX,UNXSUFFIX))
#define FILTER_LIBNAME(name)	   			LIBNAME(name)
#define EXENAME(name)			  			STRING(name)
#define PROFILENAME(name)		  			STRING(CONCAT2(name,rc))
#else
#define LIBNAME(name)                       STRING(CONCAT4(name,OFFICEUPD,DLLSUFFIX,.dll))
#define LIBSHORTNAME(name)                  STRING(CONCAT3(name,DLLSUFFIX,.dll))
#define FILTER_LIBNAME(name)	   			LIBNAME(name)
#define EXENAME(name)						STRING(CONCAT2(name,.exe))
#define PROFILENAME(name)					STRING(CONCAT2(name,.ini))
#endif

#define RESFILENAME(name,lang)              STRING(CONCAT4(name,OFFICEUPD,lang,.res))
#define SHORTRESFILENAME(name,lang)         STRING(CONCAT3(name,lang,.res))
#define READMETXTFILENAME(name,lang,ext)    STRING(CONCAT4(name,lang,.,ext))
#define READMEFILENAME(name,lang)        	STRING(CONCAT2(name,lang))
#define HELPFILENAME(name,endung) 			STRING(CONCAT3(name,.,endung))
#define EXTRAFILENAME(name,lang) 			STRING(CONCAT3(name,lang,.zip))

#define ALL_LANG(ident, resid) \
	ident (01) 		= resid; \
	ident (03) 		= resid; \
	ident (07) 		= resid; \
	ident (10) 		= resid; \
	ident (26) 		= resid; \
	ident (27) 		= resid; \
	ident (28) 		= resid; \
	ident (29) 		= resid; \
    ident (30)      = resid; \
	ident (31) 		= resid; \
	ident (33) 		= resid; \
	ident (34) 		= resid; \
    ident (35)      = resid; \
    ident (36)      = resid; \
    ident (37)      = resid; \
    ident (38)      = resid; \
	ident (39) 		= resid; \
    ident (42)      = resid; \
    ident (43)      = resid; \
	ident (44) 		= resid; \
	ident (45) 		= resid; \
	ident (46) 		= resid; \
    ident (47)      = resid; \
	ident (48) 		= resid; \
	ident (49) 		= resid; \
    ident (50)      = resid; \
    ident (53)      = resid; \
	ident (55) 		= resid; \
	ident (58) 		= resid; \
    ident (66)      = resid; \
    ident (77)      = resid; \
    ident (79)      = resid; \
	ident (81) 		= resid; \
	ident (82) 		= resid; \
	ident (86) 		= resid; \
    ident (88)      = resid; \
    ident (90)      = resid; \
    ident (91)      = resid; \
    ident (93)      = resid; \
    ident (96)      = resid; \
    ident (97)      = resid; \
    ident (99)      = resid

#define RESFILE_ALL_LANG(name) \
	Name (01) 		= RESFILENAME(name,01);		\
	Name (03) 		= RESFILENAME(name,03);		\
	Name (07) 		= RESFILENAME(name,07);		\
	Name (10) 		= RESFILENAME(name,10);		\
	Name (26) 		= RESFILENAME(name,26);		\
	Name (27) 		= RESFILENAME(name,27);		\
	Name (28) 		= RESFILENAME(name,28);		\
	Name (29) 		= RESFILENAME(name,29);		\
    Name (30)       = RESFILENAME(name,30);     \
	Name (31) 		= RESFILENAME(name,31);		\
	Name (33) 		= RESFILENAME(name,33);		\
	Name (34) 		= RESFILENAME(name,34);		\
    Name (35)       = RESFILENAME(name,35);     \
    Name (36)       = RESFILENAME(name,36);     \
    Name (37)       = RESFILENAME(name,37);     \
    Name (38)       = RESFILENAME(name,38);     \
	Name (39) 		= RESFILENAME(name,39);		\
	Name (42) 		= RESFILENAME(name,42);		\
	Name (43) 		= RESFILENAME(name,43);		\
	Name (44) 		= RESFILENAME(name,44);		\
	Name (45) 		= RESFILENAME(name,45);		\
	Name (46) 		= RESFILENAME(name,46);		\
	Name (47) 		= RESFILENAME(name,47);		\
	Name (48) 		= RESFILENAME(name,48);		\
	Name (49) 		= RESFILENAME(name,49);		\
    Name (50)       = RESFILENAME(name,50);     \
    Name (53)       = RESFILENAME(name,53);     \
	Name (55) 		= RESFILENAME(name,55);		\
	Name (58) 		= RESFILENAME(name,58);		\
	Name (66) 		= RESFILENAME(name,66);		\
	Name (77) 		= RESFILENAME(name,77);		\
	Name (79) 		= RESFILENAME(name,79);		\
	Name (81) 		= RESFILENAME(name,81);		\
	Name (82) 		= RESFILENAME(name,82);		\
	Name (86) 		= RESFILENAME(name,86);		\
    Name (88)       = RESFILENAME(name,88);     \
    Name (90)       = RESFILENAME(name,90);     \
    Name (91)       = RESFILENAME(name,91);     \
    Name (93)       = RESFILENAME(name,93);     \
    Name (96)       = RESFILENAME(name,96);     \
	Name (97) 		= RESFILENAME(name,97);		\
    Name (99)       = RESFILENAME(name,99)

#define SHORT_RESFILE_ALL_LANG(name) \
    Name (01)       = SHORTRESFILENAME(name,01);     \
    Name (03)       = SHORTRESFILENAME(name,03);     \
    Name (07)       = SHORTRESFILENAME(name,07);     \
    Name (10)       = SHORTRESFILENAME(name,10);     \
    Name (26)       = SHORTRESFILENAME(name,26);     \
    Name (27)       = SHORTRESFILENAME(name,27);     \
    Name (28)       = SHORTRESFILENAME(name,28);     \
    Name (29)       = SHORTRESFILENAME(name,29);     \
    Name (30)       = SHORTRESFILENAME(name,30);     \
    Name (31)       = SHORTRESFILENAME(name,31);     \
    Name (33)       = SHORTRESFILENAME(name,33);     \
    Name (34)       = SHORTRESFILENAME(name,34);     \
    Name (35)       = SHORTRESFILENAME(name,35);     \
    Name (36)       = SHORTRESFILENAME(name,36);     \
    Name (37)       = SHORTRESFILENAME(name,37);     \
    Name (38)       = SHORTRESFILENAME(name,38);     \
    Name (39)       = SHORTRESFILENAME(name,39);     \
    Name (42)       = SHORTRESFILENAME(name,42);     \
    Name (43)       = SHORTRESFILENAME(name,43);     \
    Name (44)       = SHORTRESFILENAME(name,44);     \
    Name (45)       = SHORTRESFILENAME(name,45);     \
    Name (46)       = SHORTRESFILENAME(name,46);     \
    Name (47)       = SHORTRESFILENAME(name,47);     \
    Name (48)       = SHORTRESFILENAME(name,48);     \
    Name (49)       = SHORTRESFILENAME(name,49);     \
    Name (50)       = SHORTRESFILENAME(name,50);     \
    Name (53)       = SHORTRESFILENAME(name,53);     \
    Name (55)       = SHORTRESFILENAME(name,55);     \
    Name (58)       = SHORTRESFILENAME(name,58);     \
    Name (66)       = SHORTRESFILENAME(name,66);     \
    Name (77)       = SHORTRESFILENAME(name,77);     \
    Name (79)       = SHORTRESFILENAME(name,79);     \
    Name (81)       = SHORTRESFILENAME(name,81);     \
    Name (82)       = SHORTRESFILENAME(name,82);     \
    Name (86)       = SHORTRESFILENAME(name,86);     \
    Name (88)       = SHORTRESFILENAME(name,88);     \
    Name (90)       = SHORTRESFILENAME(name,90);     \
    Name (91)       = SHORTRESFILENAME(name,91);     \
    Name (93)       = SHORTRESFILENAME(name,93);     \
    Name (96)       = SHORTRESFILENAME(name,96);     \
    Name (97)       = SHORTRESFILENAME(name,97);     \
    Name (99)       = SHORTRESFILENAME(name,99)

#define README_TXT_ALL_LANG(key, name, ext) \
    key (01)       = READMETXTFILENAME(name,01,ext);     \
    key (03)       = READMETXTFILENAME(name,03,ext);     \
    key (07)       = READMETXTFILENAME(name,07,ext);     \
    key (10)       = READMETXTFILENAME(name,10,ext);     \
    key (26)       = READMETXTFILENAME(name,26,ext);     \
    key (27)       = READMETXTFILENAME(name,27,ext);     \
    key (28)       = READMETXTFILENAME(name,28,ext);     \
    key (29)       = READMETXTFILENAME(name,29,ext);     \
    key (30)       = READMETXTFILENAME(name,30,ext);     \
    key (31)       = READMETXTFILENAME(name,31,ext);     \
    key (33)       = READMETXTFILENAME(name,33,ext);     \
    key (34)       = READMETXTFILENAME(name,34,ext);     \
    key (35)       = READMETXTFILENAME(name,35,ext);     \
    key (36)       = READMETXTFILENAME(name,36,ext);     \
    key (37)       = READMETXTFILENAME(name,37,ext);     \
    key (38)       = READMETXTFILENAME(name,38,ext);     \
    key (39)       = READMETXTFILENAME(name,39,ext);     \
    key (42)       = READMETXTFILENAME(name,42,ext);     \
    key (43)       = READMETXTFILENAME(name,43,ext);     \
    key (44)       = READMETXTFILENAME(name,44,ext);     \
    key (45)       = READMETXTFILENAME(name,45,ext);     \
    key (46)       = READMETXTFILENAME(name,46,ext);     \
    key (47)       = READMETXTFILENAME(name,47,ext);     \
    key (48)       = READMETXTFILENAME(name,48,ext);     \
    key (49)       = READMETXTFILENAME(name,49,ext);     \
    key (50)       = READMETXTFILENAME(name,50,ext);     \
    key (53)       = READMETXTFILENAME(name,53,ext);     \
    key (55)       = READMETXTFILENAME(name,55,ext);     \
    key (58)       = READMETXTFILENAME(name,58,ext);     \
    key (66)       = READMETXTFILENAME(name,66,ext);     \
    key (77)       = READMETXTFILENAME(name,77,ext);     \
    key (79)       = READMETXTFILENAME(name,79,ext);     \
    key (81)       = READMETXTFILENAME(name,81,ext);     \
    key (82)       = READMETXTFILENAME(name,82,ext);     \
    key (86)       = READMETXTFILENAME(name,86,ext);     \
    key (88)       = READMETXTFILENAME(name,88,ext);     \
    key (90)       = READMETXTFILENAME(name,90,ext);     \
    key (91)       = READMETXTFILENAME(name,91,ext);     \
    key (93)       = READMETXTFILENAME(name,93,ext);     \
    key (96)       = READMETXTFILENAME(name,96,ext);     \
    key (97)       = READMETXTFILENAME(name,97,ext);     \
    key (99)       = READMETXTFILENAME(name,99,ext)

#define README_ALL_LANG(key, name) \
    key (01)       = READMEFILENAME(name,01);     \
    key (03)       = READMEFILENAME(name,03);     \
    key (07)       = READMEFILENAME(name,07);     \
    key (10)       = READMEFILENAME(name,10);     \
    key (26)       = READMEFILENAME(name,26);     \
    key (27)       = READMEFILENAME(name,27);     \
    key (28)       = READMEFILENAME(name,28);     \
    key (29)       = READMEFILENAME(name,29);     \
    key (30)       = READMEFILENAME(name,30);     \
    key (31)       = READMEFILENAME(name,31);     \
    key (33)       = READMEFILENAME(name,33);     \
    key (34)       = READMEFILENAME(name,34);     \
    key (35)       = READMEFILENAME(name,35);     \
    key (36)       = READMEFILENAME(name,36);     \
    key (37)       = READMEFILENAME(name,37);     \
    key (38)       = READMEFILENAME(name,38);     \
    key (39)       = READMEFILENAME(name,39);     \
    key (42)       = READMEFILENAME(name,42);     \
    key (43)       = READMEFILENAME(name,43);     \
    key (44)       = READMEFILENAME(name,44);     \
    key (45)       = READMEFILENAME(name,45);     \
    key (46)       = READMEFILENAME(name,46);     \
    key (47)       = READMEFILENAME(name,47);     \
    key (48)       = READMEFILENAME(name,48);     \
    key (49)       = READMEFILENAME(name,49);     \
    key (50)       = READMEFILENAME(name,50);     \
    key (53)       = READMEFILENAME(name,53);     \
    key (55)       = READMEFILENAME(name,55);     \
    key (58)       = READMEFILENAME(name,58);     \
    key (66)       = READMEFILENAME(name,66);     \
    key (77)       = READMEFILENAME(name,77);     \
    key (79)       = READMEFILENAME(name,79);     \
    key (81)       = READMEFILENAME(name,81);     \
    key (82)       = READMEFILENAME(name,82);     \
    key (86)       = READMEFILENAME(name,86);     \
    key (88)       = READMEFILENAME(name,88);     \
    key (90)       = READMEFILENAME(name,90);     \
    key (91)       = READMEFILENAME(name,91);     \
    key (93)       = READMEFILENAME(name,93);     \
    key (96)       = READMEFILENAME(name,96);     \
    key (97)       = READMEFILENAME(name,97);     \
    key (99)       = READMEFILENAME(name,99)

#define EXTRA_ALL_LANG(name) \
    Name (01)       = EXTRAFILENAME(name,01);     \
    Name (03)       = EXTRAFILENAME(name,03);     \
    Name (07)       = EXTRAFILENAME(name,07);     \
    Name (10)       = EXTRAFILENAME(name,10);     \
    Name (26)       = EXTRAFILENAME(name,26);     \
    Name (27)       = EXTRAFILENAME(name,27);     \
    Name (28)       = EXTRAFILENAME(name,28);     \
    Name (29)       = EXTRAFILENAME(name,29);     \
    Name (30)       = EXTRAFILENAME(name,30);     \
    Name (31)       = EXTRAFILENAME(name,31);     \
    Name (33)       = EXTRAFILENAME(name,33);     \
    Name (34)       = EXTRAFILENAME(name,34);     \
    Name (35)       = EXTRAFILENAME(name,35);     \
    Name (36)       = EXTRAFILENAME(name,36);     \
    Name (37)       = EXTRAFILENAME(name,37);     \
    Name (38)       = EXTRAFILENAME(name,38);     \
    Name (39)       = EXTRAFILENAME(name,39);     \
    Name (42)       = EXTRAFILENAME(name,42);     \
    Name (43)       = EXTRAFILENAME(name,43);     \
    Name (44)       = EXTRAFILENAME(name,44);     \
    Name (45)       = EXTRAFILENAME(name,45);     \
    Name (46)       = EXTRAFILENAME(name,46);     \
    Name (47)       = EXTRAFILENAME(name,47);     \
    Name (48)       = EXTRAFILENAME(name,48);     \
    Name (49)       = EXTRAFILENAME(name,49);     \
    Name (50)       = EXTRAFILENAME(name,50);     \
    Name (53)       = EXTRAFILENAME(name,53);     \
    Name (55)       = EXTRAFILENAME(name,55);     \
    Name (58)       = EXTRAFILENAME(name,58);     \
    Name (66)       = EXTRAFILENAME(name,66);     \
    Name (77)       = EXTRAFILENAME(name,77);     \
    Name (79)       = EXTRAFILENAME(name,79);     \
    Name (81)       = EXTRAFILENAME(name,81);     \
    Name (82)       = EXTRAFILENAME(name,82);     \
    Name (86)       = EXTRAFILENAME(name,86);     \
    Name (88)       = EXTRAFILENAME(name,88);     \
    Name (90)       = EXTRAFILENAME(name,90);     \
    Name (91)       = EXTRAFILENAME(name,91);     \
    Name (93)       = EXTRAFILENAME(name,93);     \
    Name (96)       = EXTRAFILENAME(name,96);     \
    Name (97)       = EXTRAFILENAME(name,97);     \
    Name (99)       = EXTRAFILENAME(name,99)

#define EXTRA_IDENT_ALL_LANG(name) \
    Name (01)       = STRING(name);     \
    Name (03)       = STRING(name);     \
    Name (07)       = STRING(name);     \
    Name (10)       = STRING(name);     \
    Name (26)       = STRING(name);     \
    Name (27)       = STRING(name);     \
    Name (28)       = STRING(name);     \
    Name (29)       = STRING(name);     \
    Name (30)       = STRING(name);     \
    Name (31)       = STRING(name);     \
    Name (33)       = STRING(name);     \
    Name (34)       = STRING(name);     \
    Name (35)       = STRING(name);     \
    Name (36)       = STRING(name);     \
    Name (37)       = STRING(name);     \
    Name (38)       = STRING(name);     \
    Name (39)       = STRING(name);     \
    Name (42)       = STRING(name);     \
    Name (43)       = STRING(name);     \
    Name (44)       = STRING(name);     \
    Name (45)       = STRING(name);     \
    Name (46)       = STRING(name);     \
    Name (47)       = STRING(name);     \
    Name (48)       = STRING(name);     \
    Name (49)       = STRING(name);     \
    Name (50)       = STRING(name);     \
    Name (53)       = STRING(name);     \
    Name (55)       = STRING(name);     \
    Name (58)       = STRING(name);     \
    Name (66)       = STRING(name);     \
    Name (77)       = STRING(name);     \
    Name (79)       = STRING(name);     \
    Name (81)       = STRING(name);     \
    Name (82)       = STRING(name);     \
    Name (86)       = STRING(name);     \
    Name (88)       = STRING(name);     \
    Name (90)       = STRING(name);     \
    Name (91)       = STRING(name);     \
    Name (93)       = STRING(name);     \
    Name (96)       = STRING(name);     \
    Name (97)       = STRING(name);     \
    Name (99)       = STRING(name)

#define CONFIGHELPFILE_ALL_LANG(name) \
    Name (01)       = HELPFILENAME(name,01);     \
    Name (03)       = HELPFILENAME(name,03);     \
    Name (07)       = HELPFILENAME(name,07);     \
    Name (10)       = HELPFILENAME(name,10);     \
    Name (26)       = HELPFILENAME(name,26);     \
    Name (27)       = HELPFILENAME(name,27);     \
    Name (28)       = HELPFILENAME(name,28);     \
    Name (29)       = HELPFILENAME(name,29);     \
    Name (30)       = HELPFILENAME(name,30);     \
    Name (31)       = HELPFILENAME(name,31);     \
    Name (33)       = HELPFILENAME(name,33);     \
    Name (34)       = HELPFILENAME(name,34);     \
    Name (35)       = HELPFILENAME(name,35);     \
    Name (36)       = HELPFILENAME(name,36);     \
    Name (37)       = HELPFILENAME(name,37);     \
    Name (38)       = HELPFILENAME(name,38);     \
    Name (39)       = HELPFILENAME(name,39);     \
    Name (42)       = HELPFILENAME(name,42);     \
    Name (43)       = HELPFILENAME(name,43);     \
    Name (44)       = HELPFILENAME(name,44);     \
    Name (45)       = HELPFILENAME(name,45);     \
    Name (46)       = HELPFILENAME(name,46);     \
    Name (47)       = HELPFILENAME(name,47);     \
    Name (48)       = HELPFILENAME(name,48);     \
    Name (49)       = HELPFILENAME(name,49);     \
    Name (50)       = HELPFILENAME(name,50);     \
    Name (53)       = HELPFILENAME(name,53);     \
    Name (55)       = HELPFILENAME(name,55);     \
    Name (58)       = HELPFILENAME(name,58);     \
    Name (66)       = HELPFILENAME(name,66);     \
    Name (77)       = HELPFILENAME(name,77);     \
    Name (79)       = HELPFILENAME(name,79);     \
    Name (81)       = HELPFILENAME(name,81);     \
    Name (82)       = HELPFILENAME(name,82);     \
    Name (86)       = HELPFILENAME(name,86);     \
    Name (88)       = HELPFILENAME(name,88);     \
    Name (90)       = HELPFILENAME(name,90);     \
    Name (91)       = HELPFILENAME(name,91);     \
    Name (93)       = HELPFILENAME(name,93);     \
    Name (96)       = HELPFILENAME(name,96);     \
    Name (97)       = HELPFILENAME(name,97);     \
    Name (99)       = HELPFILENAME(name,99)

#define DELCONFIGHELPFILE_ALL_LANG(name) \
    Name (01)       = HELPFILENAME(name,01x);     \
    Name (03)       = HELPFILENAME(name,03x);     \
    Name (07)       = HELPFILENAME(name,07x);     \
    Name (10)       = HELPFILENAME(name,10x);     \
    Name (26)       = HELPFILENAME(name,26x);     \
    Name (27)       = HELPFILENAME(name,27x);     \
    Name (28)       = HELPFILENAME(name,28x);     \
    Name (29)       = HELPFILENAME(name,29x);     \
    Name (30)       = HELPFILENAME(name,30x);     \
    Name (31)       = HELPFILENAME(name,31x);     \
    Name (33)       = HELPFILENAME(name,33x);     \
    Name (34)       = HELPFILENAME(name,34x);     \
    Name (35)       = HELPFILENAME(name,35x);     \
    Name (36)       = HELPFILENAME(name,36x);     \
    Name (37)       = HELPFILENAME(name,37x);     \
    Name (38)       = HELPFILENAME(name,38x);     \
    Name (39)       = HELPFILENAME(name,39x);     \
    Name (42)       = HELPFILENAME(name,42x);     \
    Name (43)       = HELPFILENAME(name,43x);     \
    Name (44)       = HELPFILENAME(name,44x);     \
    Name (45)       = HELPFILENAME(name,45x);     \
    Name (46)       = HELPFILENAME(name,46x);     \
    Name (47)       = HELPFILENAME(name,47x);     \
    Name (48)       = HELPFILENAME(name,48x);     \
    Name (49)       = HELPFILENAME(name,49x);     \
    Name (50)       = HELPFILENAME(name,50x);     \
    Name (53)       = HELPFILENAME(name,53x);     \
    Name (55)       = HELPFILENAME(name,55x);     \
    Name (58)       = HELPFILENAME(name,58x);     \
    Name (66)       = HELPFILENAME(name,66x);     \
    Name (77)       = HELPFILENAME(name,77x);     \
    Name (79)       = HELPFILENAME(name,79x);     \
    Name (81)       = HELPFILENAME(name,81x);     \
    Name (82)       = HELPFILENAME(name,82x);     \
    Name (86)       = HELPFILENAME(name,86x);     \
    Name (88)       = HELPFILENAME(name,88x);     \
    Name (90)       = HELPFILENAME(name,90x);     \
    Name (91)       = HELPFILENAME(name,91x);     \
    Name (93)       = HELPFILENAME(name,93x);     \
    Name (96)       = HELPFILENAME(name,96x);     \
    Name (97)       = HELPFILENAME(name,97x);     \
    Name (99)       = HELPFILENAME(name,99x)

#define HELPFILENAME_ALL_LANG(name, endung) \
    Name (01)       = HELPFILENAME(name,endung);     \
    Name (03)       = HELPFILENAME(name,endung);     \
    Name (07)       = HELPFILENAME(name,endung);     \
    Name (10)       = HELPFILENAME(name,endung);     \
    Name (26)       = HELPFILENAME(name,endung);     \
    Name (27)       = HELPFILENAME(name,endung);     \
    Name (28)       = HELPFILENAME(name,endung);     \
    Name (29)       = HELPFILENAME(name,endung);     \
    Name (30)       = HELPFILENAME(name,endung);     \
    Name (31)       = HELPFILENAME(name,endung);     \
    Name (33)       = HELPFILENAME(name,endung);     \
    Name (34)       = HELPFILENAME(name,endung);     \
    Name (35)       = HELPFILENAME(name,endung);     \
    Name (36)       = HELPFILENAME(name,endung);     \
    Name (37)       = HELPFILENAME(name,endung);     \
    Name (38)       = HELPFILENAME(name,endung);     \
    Name (39)       = HELPFILENAME(name,endung);     \
    Name (42)       = HELPFILENAME(name,endung);     \
    Name (43)       = HELPFILENAME(name,endung);     \
    Name (44)       = HELPFILENAME(name,endung);     \
    Name (45)       = HELPFILENAME(name,endung);     \
    Name (46)       = HELPFILENAME(name,endung);     \
    Name (47)       = HELPFILENAME(name,endung);     \
    Name (48)       = HELPFILENAME(name,endung);     \
    Name (49)       = HELPFILENAME(name,endung);     \
    Name (50)       = HELPFILENAME(name,endung);     \
    Name (53)       = HELPFILENAME(name,endung);     \
    Name (55)       = HELPFILENAME(name,endung);     \
    Name (58)       = HELPFILENAME(name,endung);     \
    Name (66)       = HELPFILENAME(name,endung);     \
    Name (77)       = HELPFILENAME(name,endung);     \
    Name (79)       = HELPFILENAME(name,endung);     \
    Name (81)       = HELPFILENAME(name,endung);     \
    Name (82)       = HELPFILENAME(name,endung);     \
    Name (86)       = HELPFILENAME(name,endung);     \
    Name (88)       = HELPFILENAME(name,endung);     \
    Name (90)       = HELPFILENAME(name,endung);     \
    Name (91)       = HELPFILENAME(name,endung);     \
    Name (93)       = HELPFILENAME(name,endung);     \
    Name (96)       = HELPFILENAME(name,endung);     \
    Name (97)       = HELPFILENAME(name,endung);     \
    Name (99)       = HELPFILENAME(name,endung)

#define HELPDIRNAME_ALL_LANG \
    Dir (01)       = GID_DIR_HELP_01;     \
    Dir (03)       = GID_DIR_HELP_03;     \
    Dir (07)       = GID_DIR_HELP_07;     \
    Dir (10)       = GID_DIR_HELP_10;     \
    Dir (26)       = GID_DIR_HELP_26;     \
    Dir (27)       = GID_DIR_HELP_27;     \
    Dir (28)       = GID_DIR_HELP_28;     \
    Dir (29)       = GID_DIR_HELP_29;     \
    Dir (30)       = GID_DIR_HELP_30;     \
    Dir (31)       = GID_DIR_HELP_31;     \
    Dir (33)       = GID_DIR_HELP_33;     \
    Dir (34)       = GID_DIR_HELP_34;     \
    Dir (35)       = GID_DIR_HELP_35;     \
    Dir (36)       = GID_DIR_HELP_36;     \
    Dir (37)       = GID_DIR_HELP_37;     \
    Dir (38)       = GID_DIR_HELP_38;     \
    Dir (39)       = GID_DIR_HELP_39;     \
    Dir (42)       = GID_DIR_HELP_42;     \
    Dir (43)       = GID_DIR_HELP_43;     \
    Dir (44)       = GID_DIR_HELP_44;     \
    Dir (45)       = GID_DIR_HELP_45;     \
    Dir (46)       = GID_DIR_HELP_46;     \
    Dir (47)       = GID_DIR_HELP_47;     \
    Dir (48)       = GID_DIR_HELP_48;     \
    Dir (49)       = GID_DIR_HELP_49;     \
    Dir (50)       = GID_DIR_HELP_50;     \
    Dir (53)       = GID_DIR_HELP_53;     \
    Dir (55)       = GID_DIR_HELP_55;     \
    Dir (58)       = GID_DIR_HELP_58;     \
    Dir (66)       = GID_DIR_HELP_66;     \
    Dir (77)       = GID_DIR_HELP_77;     \
    Dir (79)       = GID_DIR_HELP_79;     \
    Dir (81)       = GID_DIR_HELP_81;     \
    Dir (82)       = GID_DIR_HELP_82;     \
    Dir (86)       = GID_DIR_HELP_86;     \
    Dir (88)       = GID_DIR_HELP_88;     \
    Dir (90)       = GID_DIR_HELP_90;     \
    Dir (91)       = GID_DIR_HELP_91;     \
    Dir (93)       = GID_DIR_HELP_93;     \
    Dir (96)       = GID_DIR_HELP_96;     \
    Dir (97)       = GID_DIR_HELP_97;     \
    Dir (99)       = GID_DIR_HELP_99

#define DIR_IDENT_ALL_LANG(name) \
    DosName (01)       = STRING(name);     \
    DosName (03)       = STRING(name);     \
    DosName (07)       = STRING(name);     \
    DosName (10)       = STRING(name);     \
    DosName (26)       = STRING(name);     \
    DosName (27)       = STRING(name);     \
    DosName (28)       = STRING(name);     \
    DosName (29)       = STRING(name);     \
    DosName (30)       = STRING(name);     \
    DosName (31)       = STRING(name);     \
    DosName (33)       = STRING(name);     \
    DosName (34)       = STRING(name);     \
    DosName (35)       = STRING(name);     \
    DosName (36)       = STRING(name);     \
    DosName (37)       = STRING(name);     \
    DosName (38)       = STRING(name);     \
    DosName (39)       = STRING(name);     \
    DosName (42)       = STRING(name);     \
    DosName (43)       = STRING(name);     \
    DosName (44)       = STRING(name);     \
    DosName (45)       = STRING(name);     \
    DosName (46)       = STRING(name);     \
    DosName (47)       = STRING(name);     \
    DosName (48)       = STRING(name);     \
    DosName (49)       = STRING(name);     \
    DosName (50)       = STRING(name);     \
    DosName (53)       = STRING(name);     \
    DosName (55)       = STRING(name);     \
    DosName (58)       = STRING(name);     \
    DosName (66)       = STRING(name);     \
    DosName (77)       = STRING(name);     \
    DosName (79)       = STRING(name);     \
    DosName (81)       = STRING(name);     \
    DosName (82)       = STRING(name);     \
    DosName (86)       = STRING(name);     \
    DosName (88)       = STRING(name);     \
    DosName (90)       = STRING(name);     \
    DosName (91)       = STRING(name);     \
    DosName (93)       = STRING(name);     \
    DosName (96)       = STRING(name);     \
    DosName (97)       = STRING(name);     \
    DosName (99)       = STRING(name)

#define DIR_ENGLISH_ALL_LANG            \
    DosName (01)       = "english";     \
    DosName (03)       = "portuguese";  \
    DosName (07)       = "russian";     \
    DosName (10)       = "basque";     \
    DosName (26)       = "northernsotho";     \
    DosName (27)       = "afrikaans";     \
    DosName (28)       = "zulu";     \
    DosName (29)       = "tswana";     \
    DosName (30)       = "greek";       \
    DosName (31)       = "dutch";       \
    DosName (33)       = "french";      \
    DosName (34)       = "spanish";     \
    DosName (35)       = "finnish";     \
    DosName (36)       = "hungarian";   \
    DosName (37)       = "catalan";     \
    DosName (38)       = "galician";     \
    DosName (39)       = "italian";     \
    DosName (42)       = "czech";       \
    DosName (43)       = "slovak";      \
    DosName (44)       = "english_uk";  \
    DosName (45)       = "danish";      \
    DosName (46)       = "swedish";     \
    DosName (47)       = "norwegian";   \
    DosName (48)       = "polish";      \
    DosName (49)       = "german";      \
    DosName (50)       = "slovenian";     \
    DosName (53)       = "welsh";     \
    DosName (55)       = "portuguese_brazilian";   \
    DosName (58)       = "lithuanian";   \
    DosName (66)       = "thai";        \
    DosName (77)       = "estonian";        \
    DosName (79)       = "norwegian_nynorsk";        \
    DosName (81)       = "japanese";    \
    DosName (82)       = "korean";      \
    DosName (86)       = "chinese_simplified";     \
    DosName (88)       = "chinese_traditional";    \
    DosName (90)       = "turkish";     \
    DosName (91)       = "hindi";     \
    DosName (93)       = "kannada";     \
    DosName (96)       = "arabic";     \
    DosName (97)       = "hebrew";     \
    DosName (99)       = STRING(ISO_CODE)

#define DIR_ISOLANGUAGE_ALL_LANG \
    DosName (01)       = "en";  \
    DosName (03)       = "pt";  \
    DosName (07)       = "ru";  \
    DosName (10)       = "eu";  \
    DosName (26)       = "ns";  \
    DosName (27)       = "af";  \
    DosName (28)       = "zu";  \
    DosName (29)       = "tn";  \
    DosName (30)       = "el";  \
    DosName (31)       = "nl";  \
    DosName (33)       = "fr";  \
    DosName (34)       = "es";  \
    DosName (35)       = "fi";  \
    DosName (36)       = "hu";  \
    DosName (37)       = "ca";  \
    DosName (38)       = "gl";  \
    DosName (39)       = "it";  \
    DosName (42)       = "cs";  \
    DosName (43)       = "sk";  \
    DosName (44)       = "en-GB"; \
    DosName (45)       = "da";  \
    DosName (46)       = "sv";  \
    DosName (47)       = "nb";  \
    DosName (48)       = "pl";  \
    DosName (49)       = "de";  \
    DosName (50)       = "sl";  \
    DosName (53)       = "cy";  \
    DosName (55)       = "pt-BR";  \
    DosName (58)       = "lt";  \
    DosName (66)       = "th";  \
    DosName (77)       = "et";  \
    DosName (79)       = "nn";  \
    DosName (81)       = "ja";  \
    DosName (82)       = "ko";  \
    DosName (86)       = "zh-CN"; \
    DosName (88)       = "zh-TW"; \
    DosName (90)       = "tr";  \
    DosName (91)       = "hi-IN";  \
    DosName (93)       = "kn-IN";  \
    DosName (96)       = "ar";  \
    DosName (97)       = "he";  \
    DosName (99)       = STRING(ISO_CODE)

#define DIR_ISOLANGUAGE_ALL_LANG_2 \
    DosName (01)       = "en-US";  \
    DosName (03)       = "pt";  \
    DosName (07)       = "ru";  \
    DosName (10)       = "eu";  \
    DosName (26)       = "ns";  \
    DosName (27)       = "af";  \
    DosName (28)       = "zu";  \
    DosName (29)       = "tn";  \
    DosName (30)       = "el";  \
    DosName (31)       = "nl";  \
    DosName (33)       = "fr";  \
    DosName (34)       = "es";  \
    DosName (35)       = "fi";  \
    DosName (36)       = "hu";  \
    DosName (37)       = "ca";  \
    DosName (38)       = "gl";  \
    DosName (39)       = "it";  \
    DosName (42)       = "cs";  \
    DosName (43)       = "sk";  \
    DosName (44)       = "en-GB"; \
    DosName (45)       = "da";  \
    DosName (46)       = "sv";  \
    DosName (47)       = "nb";  \
    DosName (48)       = "pl";  \
    DosName (49)       = "de";  \
    DosName (50)       = "sl";  \
    DosName (53)       = "cy";  \
    DosName (55)       = "pt-BR";  \
    DosName (58)       = "lt";  \
    DosName (66)       = "th";  \
    DosName (77)       = "et";  \
    DosName (79)       = "nn";  \
    DosName (81)       = "ja";  \
    DosName (82)       = "ko";  \
    DosName (86)       = "zh-CN"; \
    DosName (88)       = "zh-TW"; \
    DosName (90)       = "tr";  \
    DosName (91)       = "hi-IN";  \
    DosName (93)       = "kn-IN";  \
    DosName (96)       = "ar";  \
    DosName (97)       = "he";  \
    DosName (99)       = STRING(ISO_CODE)

#define ALL_LANG_STR_SECTION(ident) \
        Section (01)              = STRING(ident##-01); \
        Section (03)              = STRING(ident##-03); \
        Section (07)              = STRING(ident##-07); \
        Section (10)              = STRING(ident##-10); \
        Section (26)              = STRING(ident##-26); \
        Section (27)              = STRING(ident##-27); \
        Section (28)              = STRING(ident##-28); \
        Section (29)              = STRING(ident##-29); \
        Section (30)              = STRING(ident##-30); \
        Section (31)              = STRING(ident##-31); \
        Section (33)              = STRING(ident##-33); \
        Section (34)              = STRING(ident##-34); \
        Section (35)              = STRING(ident##-35); \
        Section (36)              = STRING(ident##-36); \
        Section (37)              = STRING(ident##-37); \
	Section (38)              = STRING(ident##-38); \
        Section (39)              = STRING(ident##-39); \
        Section (42)              = STRING(ident##-42); \
        Section (43)              = STRING(ident##-43); \
        Section (44)              = STRING(ident##-44); \
        Section (45)              = STRING(ident##-45); \
        Section (46)              = STRING(ident##-46); \
        Section (47)              = STRING(ident##-47); \
        Section (48)              = STRING(ident##-48); \
        Section (49)              = STRING(ident##-49); \
        Section (50)              = STRING(ident##-50); \
        Section (53)              = STRING(ident##-53); \
        Section (55)              = STRING(ident##-55); \
        Section (58)              = STRING(ident##-58); \
        Section (66)              = STRING(ident##-66); \
        Section (77)              = STRING(ident##-77); \
        Section (79)              = STRING(ident##-79); \
        Section (81)              = STRING(ident##-81); \
        Section (82)              = STRING(ident##-82); \
        Section (86)              = STRING(ident##-86); \
        Section (88)              = STRING(ident##-88); \
        Section (90)              = STRING(ident##-90); \
        Section (91)              = STRING(ident##-91); \
        Section (93)              = STRING(ident##-93); \
        Section (96)              = STRING(ident##-96); \
        Section (97)              = STRING(ident##-97); \
        Section (99)              = STRING(ident##-99)

// Achtung: der Zusatz "-C" ist ntig fr die Zeichenkonvertierung von DV
// Damit drfen mit diesem Makro nur noch "Type-Description"-Eintrge generiert werden
// IS: 27.04.00

#define ALL_LANG_KEY_SECTION(ident) \
        Key (01)              = STRING(ident##-01); \
        Key (03)              = STRING(ident##-03); \
        Key (07)              = STRING(ident##-07-C); \
        Key (10)              = STRING(ident##-10); \
        Key (26)              = STRING(ident##-26); \
        Key (27)              = STRING(ident##-27); \
        Key (28)              = STRING(ident##-28); \
        Key (29)              = STRING(ident##-29); \
        Key (30)              = STRING(ident##-30-C); \
        Key (31)              = STRING(ident##-31); \
        Key (33)              = STRING(ident##-33); \
        Key (34)              = STRING(ident##-34); \
        Key (35)              = STRING(ident##-35); \
        Key (36)              = STRING(ident##-36); \
        Key (37)              = STRING(ident##-37); \
        Key (38)              = STRING(ident##-38); \
        Key (50)              = STRING(ident##-50); \
        Key (39)              = STRING(ident##-39); \
        Key (42)              = STRING(ident##-42); \
        Key (43)              = STRING(ident##-43); \
        Key (44)              = STRING(ident##-44); \
        Key (45)              = STRING(ident##-45); \
        Key (46)              = STRING(ident##-46); \
        Key (47)              = STRING(ident##-47); \
        Key (48)              = STRING(ident##-48); \
        Key (49)              = STRING(ident##-49); \
        Key (55)              = STRING(ident##-55); \
        Key (58)              = STRING(ident##-58); \
        Key (66)              = STRING(ident##-66); \
        Key (77)              = STRING(ident##-77); \
        Key (79)              = STRING(ident##-79); \
        Key (81)              = STRING(ident##-81-C); \
        Key (82)              = STRING(ident##-82-C); \
        Key (86)              = STRING(ident##-86-C); \
        Key (88)              = STRING(ident##-88-C); \
        Key (90)              = STRING(ident##-90-C); \
        Key (91)              = STRING(ident##-91-C); \
        Key (93)              = STRING(ident##-93-C); \
        Key (96)              = STRING(ident##-96-C); \
        Key (97)              = STRING(ident##-97); \
        Key (99)              = STRING(ident##-99)

#define ALL_LANG_STR_KEY(ident) \
        ALL_LANG(Key,ident)

#define ALL_LANG_STR_KEY_LNG(ident) \
        ALL_LANG(Key,STR_KEY_##ident)

#define ALL_LANG_STR_VALUE_LNG(ident) \
        ALL_LANG(Value,STR_VALUE_##ident)

#define ALL_LANG_VALUE(vident) \
	ALL_LANG(Value,vident)

#define ALL_LANG_KEY(vident) \
        ALL_LANG(Key,vident)

#define FILTER_SECTION_KEY_VALUE(s,k,v) \
        ALL_LANG_STR_SECTION(s); \
        ALL_LANG_STR_KEY(k);  \
        ALL_LANG_VALUE(v)

#define KEY_ALL_LANG \
        Key (01)              = STRING(1033); \
        Key (03)              = STRING(2070); \
        Key (07)              = STRING(1049); \
        Key (10)              = STRING(1069); \
        Key (26)              = STRING(1033); \
        Key (27)              = STRING(1078); \
        Key (28)              = STRING(1077); \
        Key (29)              = STRING(1074); \
        Key (30)              = STRING(1032); \
        Key (31)              = STRING(1043); \
        Key (33)              = STRING(1036); \
        Key (34)              = STRING(1034); \
        Key (35)              = STRING(1035); \
        Key (36)              = STRING(1038); \
        Key (37)              = STRING(1037); \
        Key (38)              = STRING(1110); \
        Key (39)              = STRING(1040); \
        Key (42)              = STRING(1029); \
        Key (43)              = STRING(1051); \
        Key (45)              = STRING(1030); \
        Key (46)              = STRING(1053); \
        Key (47)              = STRING(1044); \
        Key (48)              = STRING(1045); \
        Key (49)              = STRING(1031); \
        Key (50)              = STRING(1060); \
        Key (53)              = STRING(1063); \
        Key (55)              = STRING(1046); \
        Key (58)              = STRING(1063); \
        Key (66)              = STRING(1054); \
        Key (77)              = STRING(1061); \
        Key (79)              = STRING(1079); \
        Key (81)              = STRING(1041); \
        Key (82)              = STRING(1042); \
        Key (86)              = STRING(2052); \
        Key (88)              = STRING(1028); \
        Key (90)              = STRING(1055); \
        Key (91)              = STRING(91); \
        Key (93)              = STRING(1099); \
        Key (96)              = STRING(1055); \
        Key (97)              = STRING(1037); \
        Key (99)              = STRING(ISO_CODE)

#define KEY_ALL_LANG_LETTER \
        Key (01)              = STRING(en-US); \
        Key (03)              = STRING(pt); \
        Key (07)              = STRING(ru); \
        Key (10)              = STRING(eu); \
        Key (26)              = STRING(ns); \
        Key (27)              = STRING(af); \
        Key (28)              = STRING(zu); \
        Key (29)              = STRING(tn); \
        Key (30)              = STRING(el); \
        Key (31)              = STRING(nl); \
        Key (33)              = STRING(fr); \
        Key (34)              = STRING(es); \
        Key (35)              = STRING(fi); \
        Key (36)              = STRING(hu); \
        Key (37)              = STRING(ca); \
        Key (38)              = STRING(gl); \
        Key (39)              = STRING(it); \
        Key (42)              = STRING(cs); \
        Key (43)              = STRING(sk); \
        Key (44)              = STRING(en-GB); \
        Key (45)              = STRING(da); \
        Key (46)              = STRING(sv); \
        Key (47)              = STRING(nb); \
        Key (48)              = STRING(pl); \
        Key (49)              = STRING(de); \
        Key (50)              = STRING(sl); \
        Key (53)              = STRING(cy); \
        Key (55)              = STRING(pt-BR); \
        Key (58)              = STRING(lt); \
        Key (66)              = STRING(th); \
        Key (77)              = STRING(et); \
        Key (79)              = STRING(nn); \
        Key (81)              = STRING(ja); \
        Key (82)              = STRING(ko); \
        Key (86)              = STRING(zh-CN); \
        Key (88)              = STRING(zh-TW); \
        Key (90)              = STRING(tr); \
        Key (91)              = STRING(hi-IN); \
        Key (93)              = STRING(kn-IN); \
        Key (96)              = STRING(ar); \
        Key (97)              = STRING(he); \
        Key (99)              = STRING(ISO_CODE)

#define VALUE_ALL_LANG \
        Value (01)              = STRING(1033); \
        Value (03)              = STRING(2070); \
        Value (07)              = STRING(1049); \
        Value (10)              = STRING(1069); \
        Value (26)              = STRING(1033); \
        Value (27)              = STRING(1078); \
        Value (28)              = STRING(1077); \
        Value (29)              = STRING(1074); \
        Value (30)              = STRING(1032); \
        Value (31)              = STRING(1043); \
        Value (33)              = STRING(1036); \
        Value (34)              = STRING(1034); \
        Value (35)              = STRING(1035); \
        Value (36)              = STRING(1038); \
        Value (37)              = STRING(1037); \
        Value (38)              = STRING(1110); \
        Value (39)              = STRING(1040); \
        Value (42)              = STRING(1029); \
        Value (43)              = STRING(1051); \
        Value (45)              = STRING(1030); \
        Value (46)              = STRING(1053); \
        Value (47)              = STRING(1044); \
        Value (48)              = STRING(1045); \
        Value (49)              = STRING(1031); \
        Value (50)              = STRING(1060); \
        Value (53)              = STRING(1063); \
        Value (55)              = STRING(1046); \
        Value (58)              = STRING(1063); \
        Value (66)              = STRING(1054); \
        Value (77)              = STRING(1061); \
        Value (79)              = STRING(1079); \
        Value (81)              = STRING(1041); \
        Value (82)              = STRING(1042); \
        Value (86)              = STRING(2052); \
        Value (88)              = STRING(1028); \
        Value (90)              = STRING(1055); \
        Value (91)              = STRING(91); \
        Value (93)              = STRING(1099); \
        Value (96)              = STRING(1025); \
        Value (97)              = STRING(1037); \
        Value (99)              = STRING(ISO_CODE)

#define VALUE_ALL_LANG_LETTER \
        Value (01)              = STRING(en-US); \
        Value (03)              = STRING(pt); \
        Value (07)              = STRING(ru); \
        Value (10)              = STRING(eu); \
        Value (26)              = STRING(ns); \
        Value (27)              = STRING(af); \
        Value (28)              = STRING(zu); \
        Value (29)              = STRING(tn); \
        Value (30)              = STRING(el); \
        Value (31)              = STRING(nl); \
        Value (33)              = STRING(fr); \
        Value (34)              = STRING(es); \
        Value (35)              = STRING(fi); \
        Value (36)              = STRING(hu); \
        Value (37)              = STRING(ca); \
        Value (38)              = STRING(gl); \
        Value (39)              = STRING(it); \
        Value (42)              = STRING(cs); \
        Value (43)              = STRING(sk); \
        Value (44)              = STRING(en-GB); \
        Value (45)              = STRING(da); \
        Value (46)              = STRING(sv); \
        Value (47)              = STRING(nb); \
        Value (48)              = STRING(pl); \
        Value (49)              = STRING(de); \
        Value (50)              = STRING(sl); \
        Value (53)              = STRING(cy); \
        Value (55)              = STRING(pt-BR); \
        Value (58)              = STRING(lt); \
        Value (66)              = STRING(th); \
        Value (77)              = STRING(et); \
        Value (79)              = STRING(nn); \
        Value (81)              = STRING(ja); \
        Value (82)              = STRING(ko); \
        Value (86)              = STRING(zh-CN); \
        Value (88)              = STRING(zh-TW); \
        Value (90)              = STRING(tr); \
        Value (91)              = STRING(hi-IN); \
        Value (93)              = STRING(kn-IN); \
        Value (96)              = STRING(ar); \
        Value (97)              = STRING(he); \
        Value (99)              = STRING(ISO_CODE)

#define VALUE_ALL_LANG_LETTER_NON_ASIA \
        Value (01)              = STRING(en-US); \
        Value (03)              = STRING(pt); \
        Value (07)              = STRING(ru); \
        Value (10)              = STRING(eu); \
        Value (26)              = STRING(ns); \
        Value (27)              = STRING(af); \
        Value (28)              = STRING(zu); \
        Value (29)              = STRING(tn); \
        Value (30)              = STRING(el); \
        Value (31)              = STRING(nl); \
        Value (33)              = STRING(fr); \
        Value (34)              = STRING(es); \
        Value (35)              = STRING(fi); \
        Value (36)              = STRING(hu); \
        Value (37)              = STRING(ca); \
        Value (38)              = STRING(gl); \
        Value (39)              = STRING(it); \
        Value (42)              = STRING(cs); \
        Value (43)              = STRING(sk); \
        Value (44)              = STRING(en-GB); \
        Value (45)              = STRING(da); \
        Value (46)              = STRING(sv); \
        Value (47)              = STRING(nb); \
        Value (48)              = STRING(pl); \
        Value (49)              = STRING(de); \
        Value (50)              = STRING(sl); \
        Value (53)              = STRING(cy); \
        Value (55)              = STRING(pt-BR); \
        Value (58)              = STRING(lt); \
        Value (66)              = STRING(th); \
        Value (77)              = STRING(et); \
        Value (79)              = STRING(nn); \
        Value (81)              = STRING(en-US); \
        Value (82)              = STRING(en-US); \
        Value (86)              = STRING(en-US); \
        Value (88)              = STRING(en-US); \
        Value (90)              = STRING(tr); \
        Value (91)              = STRING(hi-IN); \
        Value (93)              = STRING(kn-IN); \
        Value (96)              = STRING(ar); \
        Value (97)              = STRING(he); \
        Value (99)              = STRING(ISO_CODE)

#define VALUE_ALL_LANG_LETTER_DIR \
        Value (01)              = STRING(en); \
        Value (03)              = STRING(pt); \
        Value (07)              = STRING(ru); \
        Value (10)              = STRING(eu); \
        Value (26)              = STRING(ns); \
        Value (27)              = STRING(af); \
        Value (28)              = STRING(zu); \
        Value (29)              = STRING(tn); \
        Value (30)              = STRING(el); \
        Value (31)              = STRING(nl); \
        Value (33)              = STRING(fr); \
        Value (34)              = STRING(es); \
        Value (35)              = STRING(fi); \
        Value (36)              = STRING(hu); \
        Value (37)              = STRING(ca); \
        Value (38)              = STRING(gl); \
        Value (39)              = STRING(it); \
        Value (42)              = STRING(cs); \
        Value (43)              = STRING(sk); \
        Value (44)              = STRING(en-GB); \
        Value (45)              = STRING(da); \
        Value (46)              = STRING(sv); \
        Value (47)              = STRING(nb); \
        Value (48)              = STRING(pl); \
        Value (49)              = STRING(de); \
        Value (50)              = STRING(sl); \
        Value (53)              = STRING(cy); \
        Value (55)              = STRING(pt-BR); \
        Value (58)              = STRING(lt); \
        Value (66)              = STRING(th); \
        Value (77)              = STRING(et); \
        Value (79)              = STRING(nn); \
        Value (81)              = STRING(ja); \
        Value (82)              = STRING(ko); \
        Value (86)              = STRING(zh-CN); \
        Value (88)              = STRING(zh-TW); \
        Value (90)              = STRING(tr); \
        Value (91)              = STRING(hi-IN); \
        Value (93)              = STRING(kn-IN); \
        Value (96)              = STRING(ar); \
        Value (97)              = STRING(he); \
        Value (99)              = STRING(ISO_CODE)

#define VALUE_ALL_LANGUAGE \
        Value (01)              = STRING(01); \
        Value (03)              = STRING(03); \
        Value (07)              = STRING(07); \
        Value (10)              = STRING(10); \
        Value (26)              = STRING(26); \
        Value (27)              = STRING(27); \
        Value (28)              = STRING(28); \
        Value (29)              = STRING(29); \
        Value (30)              = STRING(30); \
        Value (31)              = STRING(31); \
        Value (33)              = STRING(33); \
        Value (34)              = STRING(34); \
        Value (35)              = STRING(35); \
        Value (36)              = STRING(36); \
        Value (37)              = STRING(37); \
        Value (38)              = STRING(38); \
        Value (39)              = STRING(39); \
        Value (42)              = STRING(42); \
        Value (43)              = STRING(43); \
        Value (44)              = STRING(44); \
        Value (45)              = STRING(45); \
        Value (46)              = STRING(46); \
        Value (47)              = STRING(47); \
        Value (48)              = STRING(48); \
        Value (49)              = STRING(49); \
        Value (50)              = STRING(50); \
        Value (53)              = STRING(53); \
        Value (55)              = STRING(55); \
        Value (58)              = STRING(58); \
        Value (66)              = STRING(66); \
        Value (77)              = STRING(77); \
        Value (79)              = STRING(79); \
        Value (81)              = STRING(81); \
        Value (82)              = STRING(82); \
        Value (86)              = STRING(86); \
        Value (88)              = STRING(88); \
        Value (90)              = STRING(90); \
        Value (91)              = STRING(91); \
        Value (93)              = STRING(93); \
        Value (96)              = STRING(96); \
        Value (97)              = STRING(97); \
        Value (99)              = STRING(99)

// ----------------------------------------------

#define JARFILENAME(name) STRING(CONCAT2(name,.jar))

#define STD_JAR_FILE(id,name) \
	File id \
		TXT_FILE_BODY; \
        Name            = JARFILENAME(name) ; \
        Dir             = GID_DIR_CLASSES; \
        Styles          = (PACKED,DONT_OVERWRITE); \
	End

#endif /* GCFG_INC */


